var _excluded = ["hasFocus", "id", "isDisabled", "label", "onChange", "value"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React from 'react';
import { StyledInput } from './partials/StyledInput';
import { StyledLabel } from './partials/StyledLabel';
import { useExternalId } from '../../hooks/useExternalId';
import { useInputValue } from '../../hooks/useInputValue';
export var Input = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var hasFocus = _ref.hasFocus,
    externalId = _ref.id,
    isDisabled = _ref.isDisabled,
    label = _ref.label,
    _onChange = _ref.onChange,
    value = _ref.value,
    rest = _objectWithoutProperties(_ref, _excluded);
  var id = useExternalId('text-input', externalId);
  var _useInputValue = useInputValue(value),
    committedValue = _useInputValue.committedValue,
    hasValue = _useInputValue.hasValue,
    onValueChange = _useInputValue.onValueChange;
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(StyledLabel, {
    $hasContent: hasValue,
    $hasFocus: hasFocus,
    htmlFor: id
  }, label), /*#__PURE__*/React.createElement(StyledInput, _extends({
    $hasLabel: true,
    ref: ref,
    disabled: isDisabled,
    id: id,
    onChange: function onChange(e) {
      onValueChange(e);
      if (_onChange) {
        _onChange(e);
      }
    },
    value: committedValue
  }, rest)));
});
Input.displayName = 'ComponentName';